package anywheresoftware.b4a.objects;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.CustomViewWrapper;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.collections.Map;
import dji.common.battery.ConnectionState;
import dji.common.flightcontroller.BatteryThresholdBehavior;
import dji.keysdk.DJIKey;
import dji.ux.widget.*;

@ShortName("DJIBatteryWidget")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"android-viewbadger"})
public class DJIBatteryWidgetWrapper extends ViewWrapper<BatteryWidget>  implements DesignerCustomView {
	private BA ba;
	private String eventName;
	 
	/*
	 * Initialize the HTML-TextView 
	 */   	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Override
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, Map props) {
		//getObject().setChecked((Boolean)props.Get("Checked"));
		CustomViewWrapper.replaceBaseWithView(base, getObject());
	}

	
	@Hide
	@Override
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		this.setObject(new BatteryWidget(ba.context));
		//getObject().ini initView(arg0, arg1, arg2);
 	}
	public void updateWidget(DJIKey key){
		getObject().updateWidget(key);
	}
	public void testKey(){
		getObject().initKey();
	}
	public void onRemainingBatteryStateChange(String behaviour){		
		getObject().onRemainingBatteryStateChange(BatteryThresholdBehavior.valueOf(behaviour));
	}
	public void onBatteryPercentageChange(int percent){		
		getObject().onBatteryPercentageChange(percent);
	}
	public void onBatteryConnectionStateChange(String state){		
		getObject().onBatteryConnectionStateChange(ConnectionState.valueOf(state));
	}

	
	
}
